/* remotely-window.c generated by valac 0.42.7, the Vala compiler
 * generated from remotely-window.vala, do not modify */

/* remotely-window.vala
 *
 * Copyright (C) 2018 Felix Häcker
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gtk-vnc.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

typedef enum  {
	ZOOM_MODE_FIT_WINDOW,
	ZOOM_MODE_BEST_FIT,
	ZOOM_MODE_ORIGINAL_SIZE
} ZoomMode;


#define TYPE_ZOOM_MODE (zoom_mode_get_type ())

#define REMOTELY_TYPE_WINDOW (remotely_window_get_type ())
#define REMOTELY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), REMOTELY_TYPE_WINDOW, RemotelyWindow))
#define REMOTELY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), REMOTELY_TYPE_WINDOW, RemotelyWindowClass))
#define REMOTELY_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), REMOTELY_TYPE_WINDOW))
#define REMOTELY_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), REMOTELY_TYPE_WINDOW))
#define REMOTELY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), REMOTELY_TYPE_WINDOW, RemotelyWindowClass))

typedef struct _RemotelyWindow RemotelyWindow;
typedef struct _RemotelyWindowClass RemotelyWindowClass;
typedef struct _RemotelyWindowPrivate RemotelyWindowPrivate;
enum  {
	REMOTELY_WINDOW_0_PROPERTY,
	REMOTELY_WINDOW_NUM_PROPERTIES
};
static GParamSpec* remotely_window_properties[REMOTELY_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RemotelyWindow {
	GtkApplicationWindow parent_instance;
	RemotelyWindowPrivate * priv;
};

struct _RemotelyWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _RemotelyWindowPrivate {
	GtkEntry* connect_entry;
	GtkStack* connect_stack;
	GtkStack* vnc_stack;
	GtkRevealer* connection_revealer;
	GtkCheckButton* view_only_checkbutton;
	GtkRevealer* notification_revealer;
	GtkLabel* notification_label;
	GtkBox* vnc_display_box;
	GtkScrolledWindow* scrolled_window;
	GtkEntry* username_entry;
	GtkLabel* username_label;
	GtkEntry* clientname_entry;
	GtkLabel* clientname_label;
	GtkEntry* password_entry;
	GtkLabel* password_label;
	VncDisplay* display;
	ZoomMode zoom_mode;
	gchar* host;
	gchar* port;
};


static gint RemotelyWindow_private_offset;
static gpointer remotely_window_parent_class = NULL;

GType zoom_mode_get_type (void) G_GNUC_CONST;
GType remotely_window_get_type (void) G_GNUC_CONST;
RemotelyWindow* remotely_window_new (GtkApplication* app);
RemotelyWindow* remotely_window_construct (GType object_type,
                                           GtkApplication* app);
static void remotely_window_connect_signals (RemotelyWindow* self);
static void remotely_window_establish_connection (RemotelyWindow* self);
static void remotely_window_disconnect_connection (RemotelyWindow* self);
static void remotely_window_authenticate_connection (RemotelyWindow* self,
                                              GValueArray* authlist);
static void remotely_window_show_notification (RemotelyWindow* self,
                                        const gchar* text);
static void __lambda6_ (RemotelyWindow* self);
static void ___lambda6__vnc_display_vnc_connected (VncDisplay* _sender,
                                            gpointer self);
static void __lambda7_ (RemotelyWindow* self);
static void remotely_window_show_new_connection_page (RemotelyWindow* self);
static void ___lambda7__vnc_display_vnc_disconnected (VncDisplay* _sender,
                                               gpointer self);
static void __lambda8_ (RemotelyWindow* self);
static void remotely_window_update_zoom_mode (RemotelyWindow* self);
static void ___lambda8__vnc_display_vnc_initialized (VncDisplay* _sender,
                                              gpointer self);
static void __lambda9_ (RemotelyWindow* self,
                 GValueArray* authlist);
static void ___lambda9__vnc_display_vnc_auth_credential (VncDisplay* _sender,
                                                  GValueArray* credList,
                                                  gpointer self);
static void __lambda10_ (RemotelyWindow* self,
                  const gchar* _error_);
static void ___lambda10__vnc_display_vnc_auth_failure (VncDisplay* _sender,
                                                const gchar* object,
                                                gpointer self);
static void __lambda11_ (RemotelyWindow* self,
                  const gchar* _error_);
static void ___lambda11__vnc_display_vnc_error (VncDisplay* _sender,
                                         const gchar* object,
                                         gpointer self);
static void __lambda12_ (RemotelyWindow* self);
static void ___lambda12__vnc_display_vnc_auth_unsupported (VncDisplay* _sender,
                                                    guint object,
                                                    gpointer self);
static void __lambda13_ (RemotelyWindow* self);
static void ___lambda13__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static void remotely_window_connect_button_clicked (RemotelyWindow* self);
static void _remotely_window_connect_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static void remotely_window_disconnect_button_clicked (RemotelyWindow* self);
static void _remotely_window_disconnect_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void remotely_window_authenticate_button_clicked (RemotelyWindow* self);
static void _remotely_window_authenticate_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                      gpointer self);
static void remotely_window_view_best_fit_button_clicked (RemotelyWindow* self);
static void _remotely_window_view_best_fit_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void remotely_window_view_fit_window_button_clicked (RemotelyWindow* self);
static void _remotely_window_view_fit_window_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self);
static void remotely_window_view_original_size_button_clicked (RemotelyWindow* self);
static void _remotely_window_view_original_size_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self);
static void remotely_window_view_only_button_clicked (RemotelyWindow* self);
static void _remotely_window_view_only_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void remotely_window_ctrlaltdel_clicked (RemotelyWindow* self);
static void _remotely_window_ctrlaltdel_clicked_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void remotely_window_notification_close_button_clicked (RemotelyWindow* self);
static void _remotely_window_notification_close_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self);
static void remotely_window_optiscale (RemotelyWindow* self,
                                gint box_width,
                                gint box_height,
                                gint image_width,
                                gint image_height,
                                gint* new_width,
                                gint* new_height);
static void remotely_window_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType
zoom_mode_get_type (void)
{
	static volatile gsize zoom_mode_type_id__volatile = 0;
	if (g_once_init_enter (&zoom_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{ZOOM_MODE_FIT_WINDOW, "ZOOM_MODE_FIT_WINDOW", "fit-window"}, {ZOOM_MODE_BEST_FIT, "ZOOM_MODE_BEST_FIT", "best-fit"}, {ZOOM_MODE_ORIGINAL_SIZE, "ZOOM_MODE_ORIGINAL_SIZE", "original-size"}, {0, NULL, NULL}};
		GType zoom_mode_type_id;
		zoom_mode_type_id = g_enum_register_static ("ZoomMode", values);
		g_once_init_leave (&zoom_mode_type_id__volatile, zoom_mode_type_id);
	}
	return zoom_mode_type_id__volatile;
}


static inline gpointer
remotely_window_get_instance_private (RemotelyWindow* self)
{
	return G_STRUCT_MEMBER_P (self, RemotelyWindow_private_offset);
}


RemotelyWindow*
remotely_window_construct (GType object_type,
                           GtkApplication* app)
{
	RemotelyWindow * self = NULL;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GdkScreen* _tmp1_;
	VncDisplay* _tmp2_;
	VncDisplay* _tmp3_;
	VncDisplay* _tmp4_;
	GtkBox* _tmp5_;
	VncDisplay* _tmp6_;
#line 56 "../src/remotely-window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 57 "../src/remotely-window.vala"
	self = (RemotelyWindow*) g_object_new (object_type, "application", app, NULL);
#line 60 "../src/remotely-window.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 60 "../src/remotely-window.vala"
	provider = _tmp0_;
#line 61 "../src/remotely-window.vala"
	gtk_css_provider_load_from_resource (provider, "/de/haeckerfelix/Remotely/ui/style.css");
#line 62 "../src/remotely-window.vala"
	_tmp1_ = gdk_screen_get_default ();
#line 62 "../src/remotely-window.vala"
	gtk_style_context_add_provider_for_screen (_tmp1_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_USER);
#line 64 "../src/remotely-window.vala"
	_tmp2_ = (VncDisplay*) vnc_display_new ();
#line 64 "../src/remotely-window.vala"
	g_object_ref_sink (_tmp2_);
#line 64 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->display);
#line 64 "../src/remotely-window.vala"
	self->priv->display = _tmp2_;
#line 65 "../src/remotely-window.vala"
	_tmp3_ = self->priv->display;
#line 65 "../src/remotely-window.vala"
	g_object_set (_tmp3_, "local-pointer", TRUE, NULL);
#line 66 "../src/remotely-window.vala"
	_tmp4_ = self->priv->display;
#line 66 "../src/remotely-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
#line 67 "../src/remotely-window.vala"
	_tmp5_ = self->priv->vnc_display_box;
#line 67 "../src/remotely-window.vala"
	_tmp6_ = self->priv->display;
#line 67 "../src/remotely-window.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 69 "../src/remotely-window.vala"
	remotely_window_connect_signals (self);
#line 56 "../src/remotely-window.vala"
	_g_object_unref0 (provider);
#line 56 "../src/remotely-window.vala"
	return self;
#line 260 "remotely-window.c"
}


RemotelyWindow*
remotely_window_new (GtkApplication* app)
{
#line 56 "../src/remotely-window.vala"
	return remotely_window_construct (REMOTELY_TYPE_WINDOW, app);
#line 269 "remotely-window.c"
}


static void
remotely_window_establish_connection (RemotelyWindow* self)
{
	GtkStack* _tmp0_;
	VncDisplay* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 72 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/remotely-window.vala"
	_tmp0_ = self->priv->connect_stack;
#line 73 "../src/remotely-window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "loading");
#line 74 "../src/remotely-window.vala"
	_tmp1_ = self->priv->display;
#line 74 "../src/remotely-window.vala"
	_tmp2_ = self->priv->host;
#line 74 "../src/remotely-window.vala"
	_tmp3_ = self->priv->port;
#line 74 "../src/remotely-window.vala"
	vnc_display_open_host (_tmp1_, _tmp2_, _tmp3_);
#line 294 "remotely-window.c"
}


static void
remotely_window_disconnect_connection (RemotelyWindow* self)
{
	VncDisplay* _tmp0_;
#line 77 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/remotely-window.vala"
	_tmp0_ = self->priv->display;
#line 78 "../src/remotely-window.vala"
	vnc_display_close (_tmp0_);
#line 308 "remotely-window.c"
}


static void
remotely_window_authenticate_connection (RemotelyWindow* self,
                                         GValueArray* authlist)
{
	GtkStack* _tmp0_;
	GtkEntry* _tmp1_;
	GtkLabel* _tmp2_;
	GtkEntry* _tmp3_;
	GtkLabel* _tmp4_;
	GtkEntry* _tmp5_;
	GtkLabel* _tmp6_;
	GValue* _tmp7_;
	gint _tmp7__length1;
#line 81 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/remotely-window.vala"
	g_return_if_fail (authlist != NULL);
#line 82 "../src/remotely-window.vala"
	_tmp0_ = self->priv->connect_stack;
#line 82 "../src/remotely-window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "authenticate");
#line 84 "../src/remotely-window.vala"
	_tmp1_ = self->priv->username_entry;
#line 84 "../src/remotely-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 85 "../src/remotely-window.vala"
	_tmp2_ = self->priv->username_label;
#line 85 "../src/remotely-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 86 "../src/remotely-window.vala"
	_tmp3_ = self->priv->clientname_entry;
#line 86 "../src/remotely-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 87 "../src/remotely-window.vala"
	_tmp4_ = self->priv->clientname_label;
#line 87 "../src/remotely-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 88 "../src/remotely-window.vala"
	_tmp5_ = self->priv->password_entry;
#line 88 "../src/remotely-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 89 "../src/remotely-window.vala"
	_tmp6_ = self->priv->password_label;
#line 89 "../src/remotely-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, FALSE);
#line 91 "../src/remotely-window.vala"
	_tmp7_ = authlist->values;
#line 91 "../src/remotely-window.vala"
	_tmp7__length1 = (gint) authlist->n_values;
#line 361 "remotely-window.c"
	{
		GValue* val_collection = NULL;
		gint val_collection_length1 = 0;
		gint _val_collection_size_ = 0;
		gint val_it = 0;
#line 91 "../src/remotely-window.vala"
		val_collection = _tmp7_;
#line 91 "../src/remotely-window.vala"
		val_collection_length1 = _tmp7__length1;
#line 91 "../src/remotely-window.vala"
		for (val_it = 0; val_it < _tmp7__length1; val_it = val_it + 1) {
#line 373 "remotely-window.c"
			GValue _tmp8_ = {0};
			GValue val = {0};
#line 91 "../src/remotely-window.vala"
			if (G_IS_VALUE (&val_collection[val_it])) {
#line 91 "../src/remotely-window.vala"
				g_value_init (&_tmp8_, G_VALUE_TYPE (&val_collection[val_it]));
#line 91 "../src/remotely-window.vala"
				g_value_copy (&val_collection[val_it], &_tmp8_);
#line 382 "remotely-window.c"
			} else {
#line 91 "../src/remotely-window.vala"
				_tmp8_ = val_collection[val_it];
#line 386 "remotely-window.c"
			}
#line 91 "../src/remotely-window.vala"
			val = _tmp8_;
#line 390 "remotely-window.c"
			{
				VncDisplayCredential cred = 0;
				VncDisplayCredential _tmp9_;
#line 92 "../src/remotely-window.vala"
				cred = (VncDisplayCredential) g_value_get_enum (&val);
#line 93 "../src/remotely-window.vala"
				_tmp9_ = cred;
#line 93 "../src/remotely-window.vala"
				switch (_tmp9_) {
#line 93 "../src/remotely-window.vala"
					case VNC_DISPLAY_CREDENTIAL_PASSWORD:
#line 402 "remotely-window.c"
					{
						GtkEntry* _tmp10_;
						GtkLabel* _tmp11_;
#line 94 "../src/remotely-window.vala"
						_tmp10_ = self->priv->password_entry;
#line 94 "../src/remotely-window.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp10_, TRUE);
#line 94 "../src/remotely-window.vala"
						_tmp11_ = self->priv->password_label;
#line 94 "../src/remotely-window.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp11_, TRUE);
#line 94 "../src/remotely-window.vala"
						break;
#line 416 "remotely-window.c"
					}
#line 93 "../src/remotely-window.vala"
					case VNC_DISPLAY_CREDENTIAL_USERNAME:
#line 420 "remotely-window.c"
					{
						GtkEntry* _tmp12_;
						GtkLabel* _tmp13_;
#line 95 "../src/remotely-window.vala"
						_tmp12_ = self->priv->username_entry;
#line 95 "../src/remotely-window.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp12_, TRUE);
#line 95 "../src/remotely-window.vala"
						_tmp13_ = self->priv->username_label;
#line 95 "../src/remotely-window.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp13_, TRUE);
#line 95 "../src/remotely-window.vala"
						break;
#line 434 "remotely-window.c"
					}
#line 93 "../src/remotely-window.vala"
					case VNC_DISPLAY_CREDENTIAL_CLIENTNAME:
#line 438 "remotely-window.c"
					{
						GtkEntry* _tmp14_;
						GtkLabel* _tmp15_;
#line 96 "../src/remotely-window.vala"
						_tmp14_ = self->priv->clientname_entry;
#line 96 "../src/remotely-window.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp14_, TRUE);
#line 96 "../src/remotely-window.vala"
						_tmp15_ = self->priv->clientname_label;
#line 96 "../src/remotely-window.vala"
						gtk_widget_set_visible ((GtkWidget*) _tmp15_, TRUE);
#line 96 "../src/remotely-window.vala"
						break;
#line 452 "remotely-window.c"
					}
					default:
#line 93 "../src/remotely-window.vala"
					break;
#line 457 "remotely-window.c"
				}
#line 91 "../src/remotely-window.vala"
				G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 461 "remotely-window.c"
			}
		}
	}
}


static void
remotely_window_show_notification (RemotelyWindow* self,
                                   const gchar* text)
{
	GtkLabel* _tmp0_;
	GtkRevealer* _tmp1_;
#line 101 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/remotely-window.vala"
	g_return_if_fail (text != NULL);
#line 102 "../src/remotely-window.vala"
	_tmp0_ = self->priv->notification_label;
#line 102 "../src/remotely-window.vala"
	gtk_label_set_label (_tmp0_, text);
#line 103 "../src/remotely-window.vala"
	_tmp1_ = self->priv->notification_revealer;
#line 103 "../src/remotely-window.vala"
	gtk_revealer_set_reveal_child (_tmp1_, TRUE);
#line 486 "remotely-window.c"
}


static void
__lambda6_ (RemotelyWindow* self)
{
	GtkStack* _tmp0_;
#line 108 "../src/remotely-window.vala"
	_tmp0_ = self->priv->connect_stack;
#line 108 "../src/remotely-window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "loading");
#line 498 "remotely-window.c"
}


static void
___lambda6__vnc_display_vnc_connected (VncDisplay* _sender,
                                       gpointer self)
{
#line 107 "../src/remotely-window.vala"
	__lambda6_ ((RemotelyWindow*) self);
#line 508 "remotely-window.c"
}


static void
__lambda7_ (RemotelyWindow* self)
{
#line 112 "../src/remotely-window.vala"
	remotely_window_show_new_connection_page (self);
#line 517 "remotely-window.c"
}


static void
___lambda7__vnc_display_vnc_disconnected (VncDisplay* _sender,
                                          gpointer self)
{
#line 111 "../src/remotely-window.vala"
	__lambda7_ ((RemotelyWindow*) self);
#line 527 "remotely-window.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 120 "../src/remotely-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 536 "remotely-window.c"
}


static void
__lambda8_ (RemotelyWindow* self)
{
	GtkStack* _tmp0_;
	GtkRevealer* _tmp1_;
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp2_;
	GtkSettings* _tmp3_;
#line 116 "../src/remotely-window.vala"
	_tmp0_ = self->priv->vnc_stack;
#line 116 "../src/remotely-window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "connection");
#line 117 "../src/remotely-window.vala"
	_tmp1_ = self->priv->connection_revealer;
#line 117 "../src/remotely-window.vala"
	gtk_revealer_set_reveal_child (_tmp1_, TRUE);
#line 118 "../src/remotely-window.vala"
	remotely_window_update_zoom_mode (self);
#line 120 "../src/remotely-window.vala"
	_tmp2_ = gtk_settings_get_default ();
#line 120 "../src/remotely-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 120 "../src/remotely-window.vala"
	gtk_settings = _tmp3_;
#line 121 "../src/remotely-window.vala"
	g_object_set (gtk_settings, "gtk-application-prefer-dark-theme", TRUE, NULL);
#line 115 "../src/remotely-window.vala"
	_g_object_unref0 (gtk_settings);
#line 568 "remotely-window.c"
}


static void
___lambda8__vnc_display_vnc_initialized (VncDisplay* _sender,
                                         gpointer self)
{
#line 115 "../src/remotely-window.vala"
	__lambda8_ ((RemotelyWindow*) self);
#line 578 "remotely-window.c"
}


static void
__lambda9_ (RemotelyWindow* self,
            GValueArray* authlist)
{
#line 124 "../src/remotely-window.vala"
	g_return_if_fail (authlist != NULL);
#line 125 "../src/remotely-window.vala"
	remotely_window_authenticate_connection (self, authlist);
#line 590 "remotely-window.c"
}


static void
___lambda9__vnc_display_vnc_auth_credential (VncDisplay* _sender,
                                             GValueArray* credList,
                                             gpointer self)
{
#line 124 "../src/remotely-window.vala"
	__lambda9_ ((RemotelyWindow*) self, credList);
#line 601 "remotely-window.c"
}


static void
__lambda10_ (RemotelyWindow* self,
             const gchar* _error_)
{
#line 128 "../src/remotely-window.vala"
	g_return_if_fail (_error_ != NULL);
#line 129 "../src/remotely-window.vala"
	remotely_window_show_notification (self, "Authentication error");
#line 130 "../src/remotely-window.vala"
	remotely_window_show_new_connection_page (self);
#line 615 "remotely-window.c"
}


static void
___lambda10__vnc_display_vnc_auth_failure (VncDisplay* _sender,
                                           const gchar* object,
                                           gpointer self)
{
#line 128 "../src/remotely-window.vala"
	__lambda10_ ((RemotelyWindow*) self, object);
#line 626 "remotely-window.c"
}


static void
__lambda11_ (RemotelyWindow* self,
             const gchar* _error_)
{
#line 133 "../src/remotely-window.vala"
	g_return_if_fail (_error_ != NULL);
#line 134 "../src/remotely-window.vala"
	remotely_window_show_notification (self, _error_);
#line 135 "../src/remotely-window.vala"
	remotely_window_show_new_connection_page (self);
#line 640 "remotely-window.c"
}


static void
___lambda11__vnc_display_vnc_error (VncDisplay* _sender,
                                    const gchar* object,
                                    gpointer self)
{
#line 133 "../src/remotely-window.vala"
	__lambda11_ ((RemotelyWindow*) self, object);
#line 651 "remotely-window.c"
}


static void
__lambda12_ (RemotelyWindow* self)
{
#line 139 "../src/remotely-window.vala"
	remotely_window_show_notification (self, "Authentication method is not supported");
#line 140 "../src/remotely-window.vala"
	remotely_window_show_new_connection_page (self);
#line 662 "remotely-window.c"
}


static void
___lambda12__vnc_display_vnc_auth_unsupported (VncDisplay* _sender,
                                               guint object,
                                               gpointer self)
{
#line 138 "../src/remotely-window.vala"
	__lambda12_ ((RemotelyWindow*) self);
#line 673 "remotely-window.c"
}


static void
__lambda13_ (RemotelyWindow* self)
{
#line 144 "../src/remotely-window.vala"
	remotely_window_update_zoom_mode (self);
#line 682 "remotely-window.c"
}


static void
___lambda13__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 143 "../src/remotely-window.vala"
	__lambda13_ ((RemotelyWindow*) self);
#line 693 "remotely-window.c"
}


static void
remotely_window_connect_signals (RemotelyWindow* self)
{
	VncDisplay* _tmp0_;
	VncDisplay* _tmp1_;
	VncDisplay* _tmp2_;
	VncDisplay* _tmp3_;
	VncDisplay* _tmp4_;
	VncDisplay* _tmp5_;
	VncDisplay* _tmp6_;
#line 106 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/remotely-window.vala"
	_tmp0_ = self->priv->display;
#line 107 "../src/remotely-window.vala"
	g_signal_connect_object (_tmp0_, "vnc-connected", (GCallback) ___lambda6__vnc_display_vnc_connected, self, 0);
#line 111 "../src/remotely-window.vala"
	_tmp1_ = self->priv->display;
#line 111 "../src/remotely-window.vala"
	g_signal_connect_object (_tmp1_, "vnc-disconnected", (GCallback) ___lambda7__vnc_display_vnc_disconnected, self, 0);
#line 115 "../src/remotely-window.vala"
	_tmp2_ = self->priv->display;
#line 115 "../src/remotely-window.vala"
	g_signal_connect_object (_tmp2_, "vnc-initialized", (GCallback) ___lambda8__vnc_display_vnc_initialized, self, 0);
#line 124 "../src/remotely-window.vala"
	_tmp3_ = self->priv->display;
#line 124 "../src/remotely-window.vala"
	g_signal_connect_object (_tmp3_, "vnc-auth-credential", (GCallback) ___lambda9__vnc_display_vnc_auth_credential, self, 0);
#line 128 "../src/remotely-window.vala"
	_tmp4_ = self->priv->display;
#line 128 "../src/remotely-window.vala"
	g_signal_connect_object (_tmp4_, "vnc-auth-failure", (GCallback) ___lambda10__vnc_display_vnc_auth_failure, self, 0);
#line 133 "../src/remotely-window.vala"
	_tmp5_ = self->priv->display;
#line 133 "../src/remotely-window.vala"
	g_signal_connect_object (_tmp5_, "vnc-error", (GCallback) ___lambda11__vnc_display_vnc_error, self, 0);
#line 138 "../src/remotely-window.vala"
	_tmp6_ = self->priv->display;
#line 138 "../src/remotely-window.vala"
	g_signal_connect_object (_tmp6_, "vnc-auth-unsupported", (GCallback) ___lambda12__vnc_display_vnc_auth_unsupported, self, 0);
#line 143 "../src/remotely-window.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) ___lambda13__gtk_widget_size_allocate, self, 0);
#line 739 "remotely-window.c"
}


static void
remotely_window_show_new_connection_page (RemotelyWindow* self)
{
	GtkStack* _tmp0_;
	GtkStack* _tmp1_;
	GtkRevealer* _tmp2_;
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp3_;
	GtkSettings* _tmp4_;
#line 148 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/remotely-window.vala"
	_tmp0_ = self->priv->vnc_stack;
#line 149 "../src/remotely-window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "new-connection");
#line 150 "../src/remotely-window.vala"
	_tmp1_ = self->priv->connect_stack;
#line 150 "../src/remotely-window.vala"
	gtk_stack_set_visible_child_name (_tmp1_, "host");
#line 151 "../src/remotely-window.vala"
	_tmp2_ = self->priv->connection_revealer;
#line 151 "../src/remotely-window.vala"
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
#line 153 "../src/remotely-window.vala"
	_tmp3_ = gtk_settings_get_default ();
#line 153 "../src/remotely-window.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 153 "../src/remotely-window.vala"
	gtk_settings = _tmp4_;
#line 154 "../src/remotely-window.vala"
	g_object_set (gtk_settings, "gtk-application-prefer-dark-theme", FALSE, NULL);
#line 148 "../src/remotely-window.vala"
	_g_object_unref0 (gtk_settings);
#line 776 "remotely-window.c"
}


static void
remotely_window_connect_button_clicked (RemotelyWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	gchar** connection = NULL;
	GtkEntry* _tmp5_;
	const gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint connection_length1;
	gint _connection_size_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	const gchar* _tmp10_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	const gchar* _tmp23_;
	gchar* _tmp24_;
#line 158 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/remotely-window.vala"
	_tmp1_ = self->priv->connect_entry;
#line 159 "../src/remotely-window.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 159 "../src/remotely-window.vala"
	if (g_strcmp0 (_tmp2_, "") == 0) {
#line 159 "../src/remotely-window.vala"
		_tmp0_ = TRUE;
#line 817 "remotely-window.c"
	} else {
		GtkEntry* _tmp3_;
		const gchar* _tmp4_;
#line 159 "../src/remotely-window.vala"
		_tmp3_ = self->priv->connect_entry;
#line 159 "../src/remotely-window.vala"
		_tmp4_ = gtk_entry_get_text (_tmp3_);
#line 159 "../src/remotely-window.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 827 "remotely-window.c"
	}
#line 159 "../src/remotely-window.vala"
	if (_tmp0_) {
#line 160 "../src/remotely-window.vala"
		return;
#line 833 "remotely-window.c"
	}
#line 162 "../src/remotely-window.vala"
	_tmp5_ = self->priv->connect_entry;
#line 162 "../src/remotely-window.vala"
	_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 162 "../src/remotely-window.vala"
	_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, ":", 0);
#line 162 "../src/remotely-window.vala"
	connection = _tmp8_;
#line 162 "../src/remotely-window.vala"
	connection_length1 = _vala_array_length (_tmp7_);
#line 162 "../src/remotely-window.vala"
	_connection_size_ = connection_length1;
#line 163 "../src/remotely-window.vala"
	_tmp9_ = connection;
#line 163 "../src/remotely-window.vala"
	_tmp9__length1 = connection_length1;
#line 163 "../src/remotely-window.vala"
	_tmp10_ = _tmp9_[1];
#line 163 "../src/remotely-window.vala"
	if (_tmp10_ == NULL) {
#line 855 "remotely-window.c"
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
#line 163 "../src/remotely-window.vala"
		_tmp11_ = connection;
#line 163 "../src/remotely-window.vala"
		_tmp11__length1 = connection_length1;
#line 163 "../src/remotely-window.vala"
		_tmp12_ = g_strdup ("5900");
#line 163 "../src/remotely-window.vala"
		_g_free0 (_tmp11_[1]);
#line 163 "../src/remotely-window.vala"
		_tmp11_[1] = _tmp12_;
#line 869 "remotely-window.c"
	}
#line 164 "../src/remotely-window.vala"
	_tmp13_ = connection;
#line 164 "../src/remotely-window.vala"
	_tmp13__length1 = connection_length1;
#line 164 "../src/remotely-window.vala"
	_tmp14_ = _tmp13_[1];
#line 164 "../src/remotely-window.vala"
	if (atoi (_tmp14_) < 5900) {
#line 879 "remotely-window.c"
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 164 "../src/remotely-window.vala"
		_tmp15_ = connection;
#line 164 "../src/remotely-window.vala"
		_tmp15__length1 = connection_length1;
#line 164 "../src/remotely-window.vala"
		_tmp16_ = connection;
#line 164 "../src/remotely-window.vala"
		_tmp16__length1 = connection_length1;
#line 164 "../src/remotely-window.vala"
		_tmp17_ = _tmp16_[1];
#line 164 "../src/remotely-window.vala"
		_tmp18_ = g_strdup_printf ("%i", atoi (_tmp17_) + 5900);
#line 164 "../src/remotely-window.vala"
		_g_free0 (_tmp15_[1]);
#line 164 "../src/remotely-window.vala"
		_tmp15_[1] = _tmp18_;
#line 902 "remotely-window.c"
	}
#line 166 "../src/remotely-window.vala"
	_tmp19_ = connection;
#line 166 "../src/remotely-window.vala"
	_tmp19__length1 = connection_length1;
#line 166 "../src/remotely-window.vala"
	_tmp20_ = _tmp19_[0];
#line 166 "../src/remotely-window.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 166 "../src/remotely-window.vala"
	_g_free0 (self->priv->host);
#line 166 "../src/remotely-window.vala"
	self->priv->host = _tmp21_;
#line 167 "../src/remotely-window.vala"
	_tmp22_ = connection;
#line 167 "../src/remotely-window.vala"
	_tmp22__length1 = connection_length1;
#line 167 "../src/remotely-window.vala"
	_tmp23_ = _tmp22_[1];
#line 167 "../src/remotely-window.vala"
	_tmp24_ = g_strdup (_tmp23_);
#line 167 "../src/remotely-window.vala"
	_g_free0 (self->priv->port);
#line 167 "../src/remotely-window.vala"
	self->priv->port = _tmp24_;
#line 169 "../src/remotely-window.vala"
	remotely_window_establish_connection (self);
#line 170 "../src/remotely-window.vala"
	remotely_window_update_zoom_mode (self);
#line 158 "../src/remotely-window.vala"
	connection = (_vala_array_free (connection, connection_length1, (GDestroyNotify) g_free), NULL);
#line 934 "remotely-window.c"
}


static void
_remotely_window_connect_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_connect_button_clicked ((RemotelyWindow*) self);
#line 944 "remotely-window.c"
}


static void
remotely_window_disconnect_button_clicked (RemotelyWindow* self)
{
#line 174 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/remotely-window.vala"
	remotely_window_disconnect_connection (self);
#line 955 "remotely-window.c"
}


static void
_remotely_window_disconnect_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_disconnect_button_clicked ((RemotelyWindow*) self);
#line 965 "remotely-window.c"
}


static void
remotely_window_authenticate_button_clicked (RemotelyWindow* self)
{
	VncDisplay* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	VncDisplay* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	VncDisplay* _tmp6_;
	GtkEntry* _tmp7_;
	const gchar* _tmp8_;
#line 179 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/remotely-window.vala"
	_tmp0_ = self->priv->display;
#line 180 "../src/remotely-window.vala"
	_tmp1_ = self->priv->password_entry;
#line 180 "../src/remotely-window.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 180 "../src/remotely-window.vala"
	vnc_display_set_credential (_tmp0_, (gint) VNC_DISPLAY_CREDENTIAL_PASSWORD, _tmp2_);
#line 181 "../src/remotely-window.vala"
	_tmp3_ = self->priv->display;
#line 181 "../src/remotely-window.vala"
	_tmp4_ = self->priv->username_entry;
#line 181 "../src/remotely-window.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 181 "../src/remotely-window.vala"
	vnc_display_set_credential (_tmp3_, (gint) VNC_DISPLAY_CREDENTIAL_USERNAME, _tmp5_);
#line 182 "../src/remotely-window.vala"
	_tmp6_ = self->priv->display;
#line 182 "../src/remotely-window.vala"
	_tmp7_ = self->priv->clientname_entry;
#line 182 "../src/remotely-window.vala"
	_tmp8_ = gtk_entry_get_text (_tmp7_);
#line 182 "../src/remotely-window.vala"
	vnc_display_set_credential (_tmp6_, (gint) VNC_DISPLAY_CREDENTIAL_CLIENTNAME, _tmp8_);
#line 1007 "remotely-window.c"
}


static void
_remotely_window_authenticate_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_authenticate_button_clicked ((RemotelyWindow*) self);
#line 1017 "remotely-window.c"
}


static void
remotely_window_view_best_fit_button_clicked (RemotelyWindow* self)
{
#line 186 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/remotely-window.vala"
	self->priv->zoom_mode = ZOOM_MODE_BEST_FIT;
#line 188 "../src/remotely-window.vala"
	remotely_window_update_zoom_mode (self);
#line 1030 "remotely-window.c"
}


static void
_remotely_window_view_best_fit_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_view_best_fit_button_clicked ((RemotelyWindow*) self);
#line 1040 "remotely-window.c"
}


static void
remotely_window_view_fit_window_button_clicked (RemotelyWindow* self)
{
#line 192 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/remotely-window.vala"
	self->priv->zoom_mode = ZOOM_MODE_FIT_WINDOW;
#line 194 "../src/remotely-window.vala"
	remotely_window_update_zoom_mode (self);
#line 1053 "remotely-window.c"
}


static void
_remotely_window_view_fit_window_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_view_fit_window_button_clicked ((RemotelyWindow*) self);
#line 1063 "remotely-window.c"
}


static void
remotely_window_view_original_size_button_clicked (RemotelyWindow* self)
{
#line 198 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/remotely-window.vala"
	self->priv->zoom_mode = ZOOM_MODE_ORIGINAL_SIZE;
#line 200 "../src/remotely-window.vala"
	remotely_window_update_zoom_mode (self);
#line 1076 "remotely-window.c"
}


static void
_remotely_window_view_original_size_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_view_original_size_button_clicked ((RemotelyWindow*) self);
#line 1086 "remotely-window.c"
}


static void
remotely_window_view_only_button_clicked (RemotelyWindow* self)
{
	VncDisplay* _tmp0_;
	GtkCheckButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 204 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/remotely-window.vala"
	_tmp0_ = self->priv->display;
#line 205 "../src/remotely-window.vala"
	_tmp1_ = self->priv->view_only_checkbutton;
#line 205 "../src/remotely-window.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 205 "../src/remotely-window.vala"
	_tmp3_ = _tmp2_;
#line 205 "../src/remotely-window.vala"
	vnc_display_set_read_only (_tmp0_, _tmp3_);
#line 1109 "remotely-window.c"
}


static void
_remotely_window_view_only_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_view_only_button_clicked ((RemotelyWindow*) self);
#line 1119 "remotely-window.c"
}


static void
remotely_window_ctrlaltdel_clicked (RemotelyWindow* self)
{
	guint* keys = NULL;
	guint* _tmp0_;
	gint keys_length1;
	gint _keys_size_;
	VncDisplay* _tmp1_;
#line 209 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/remotely-window.vala"
	_tmp0_ = g_new0 (guint, 3);
#line 210 "../src/remotely-window.vala"
	_tmp0_[0] = (guint) 0xFFE3;
#line 210 "../src/remotely-window.vala"
	_tmp0_[1] = (guint) 0xFFE9;
#line 210 "../src/remotely-window.vala"
	_tmp0_[2] = (guint) 0xFFFF;
#line 210 "../src/remotely-window.vala"
	keys = _tmp0_;
#line 210 "../src/remotely-window.vala"
	keys_length1 = 3;
#line 210 "../src/remotely-window.vala"
	_keys_size_ = keys_length1;
#line 211 "../src/remotely-window.vala"
	_tmp1_ = self->priv->display;
#line 211 "../src/remotely-window.vala"
	vnc_display_send_keys (_tmp1_, keys, keys_length1);
#line 209 "../src/remotely-window.vala"
	keys = (g_free (keys), NULL);
#line 1153 "remotely-window.c"
}


static void
_remotely_window_ctrlaltdel_clicked_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_ctrlaltdel_clicked ((RemotelyWindow*) self);
#line 1163 "remotely-window.c"
}


static void
remotely_window_notification_close_button_clicked (RemotelyWindow* self)
{
	GtkRevealer* _tmp0_;
#line 215 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/remotely-window.vala"
	_tmp0_ = self->priv->notification_revealer;
#line 216 "../src/remotely-window.vala"
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
#line 1177 "remotely-window.c"
}


static void
_remotely_window_notification_close_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_notification_close_button_clicked ((RemotelyWindow*) self);
#line 1187 "remotely-window.c"
}


static void
remotely_window_update_zoom_mode (RemotelyWindow* self)
{
	VncDisplay* _tmp0_;
	VncDisplay* _tmp1_;
	GtkScrolledWindow* _tmp2_;
	GtkScrolledWindow* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	ZoomMode _tmp6_;
#line 219 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/remotely-window.vala"
	_tmp0_ = self->priv->display;
#line 221 "../src/remotely-window.vala"
	g_object_set ((GtkWidget*) _tmp0_, "expand", FALSE, NULL);
#line 222 "../src/remotely-window.vala"
	_tmp1_ = self->priv->display;
#line 222 "../src/remotely-window.vala"
	vnc_display_set_scaling (_tmp1_, FALSE);
#line 223 "../src/remotely-window.vala"
	_tmp2_ = self->priv->scrolled_window;
#line 223 "../src/remotely-window.vala"
	g_object_set (_tmp2_, "hscrollbar-policy", GTK_POLICY_ALWAYS, NULL);
#line 224 "../src/remotely-window.vala"
	_tmp3_ = self->priv->scrolled_window;
#line 224 "../src/remotely-window.vala"
	g_object_set (_tmp3_, "vscrollbar-policy", GTK_POLICY_ALWAYS, NULL);
#line 225 "../src/remotely-window.vala"
	_tmp4_ = self->priv->vnc_display_box;
#line 225 "../src/remotely-window.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_FILL);
#line 226 "../src/remotely-window.vala"
	_tmp5_ = self->priv->vnc_display_box;
#line 226 "../src/remotely-window.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_FILL);
#line 228 "../src/remotely-window.vala"
	_tmp6_ = self->priv->zoom_mode;
#line 228 "../src/remotely-window.vala"
	switch (_tmp6_) {
#line 228 "../src/remotely-window.vala"
		case ZOOM_MODE_FIT_WINDOW:
#line 1233 "remotely-window.c"
		{
			{
				GtkScrolledWindow* _tmp7_;
				GtkScrolledWindow* _tmp8_;
				VncDisplay* _tmp9_;
				VncDisplay* _tmp10_;
				VncDisplay* _tmp11_;
				VncDisplay* _tmp12_;
#line 230 "../src/remotely-window.vala"
				_tmp7_ = self->priv->scrolled_window;
#line 230 "../src/remotely-window.vala"
				g_object_set (_tmp7_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 231 "../src/remotely-window.vala"
				_tmp8_ = self->priv->scrolled_window;
#line 231 "../src/remotely-window.vala"
				g_object_set (_tmp8_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 233 "../src/remotely-window.vala"
				_tmp9_ = self->priv->display;
#line 233 "../src/remotely-window.vala"
				g_object_set ((GtkWidget*) _tmp9_, "expand", TRUE, NULL);
#line 234 "../src/remotely-window.vala"
				_tmp10_ = self->priv->display;
#line 234 "../src/remotely-window.vala"
				vnc_display_set_scaling (_tmp10_, TRUE);
#line 235 "../src/remotely-window.vala"
				_tmp11_ = self->priv->display;
#line 235 "../src/remotely-window.vala"
				g_object_set ((GtkWidget*) _tmp11_, "height-request", 0, NULL);
#line 236 "../src/remotely-window.vala"
				_tmp12_ = self->priv->display;
#line 236 "../src/remotely-window.vala"
				g_object_set ((GtkWidget*) _tmp12_, "width-request", 0, NULL);
#line 237 "../src/remotely-window.vala"
				break;
#line 1268 "remotely-window.c"
			}
		}
#line 228 "../src/remotely-window.vala"
		case ZOOM_MODE_BEST_FIT:
#line 1273 "remotely-window.c"
		{
			{
				VncDisplay* _tmp13_;
				gint new_width = 0;
				gint new_height = 0;
				GtkStack* _tmp14_;
				GtkStack* _tmp15_;
				VncDisplay* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				VncDisplay* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_ = 0;
				gint _tmp23_ = 0;
				VncDisplay* _tmp24_;
				gint _tmp25_;
				VncDisplay* _tmp26_;
				gint _tmp27_;
				GtkBox* _tmp28_;
				GtkBox* _tmp29_;
#line 240 "../src/remotely-window.vala"
				_tmp13_ = self->priv->display;
#line 240 "../src/remotely-window.vala"
				vnc_display_set_scaling (_tmp13_, TRUE);
#line 244 "../src/remotely-window.vala"
				_tmp14_ = self->priv->vnc_stack;
#line 244 "../src/remotely-window.vala"
				_tmp15_ = self->priv->vnc_stack;
#line 244 "../src/remotely-window.vala"
				_tmp16_ = self->priv->display;
#line 244 "../src/remotely-window.vala"
				_tmp17_ = vnc_display_get_width (_tmp16_);
#line 244 "../src/remotely-window.vala"
				_tmp18_ = _tmp17_;
#line 244 "../src/remotely-window.vala"
				_tmp19_ = self->priv->display;
#line 244 "../src/remotely-window.vala"
				_tmp20_ = vnc_display_get_height (_tmp19_);
#line 244 "../src/remotely-window.vala"
				_tmp21_ = _tmp20_;
#line 244 "../src/remotely-window.vala"
				remotely_window_optiscale (self, gtk_widget_get_allocated_width ((GtkWidget*) _tmp14_), gtk_widget_get_allocated_height ((GtkWidget*) _tmp15_), _tmp18_, _tmp21_, &_tmp22_, &_tmp23_);
#line 244 "../src/remotely-window.vala"
				new_width = _tmp22_;
#line 244 "../src/remotely-window.vala"
				new_height = _tmp23_;
#line 245 "../src/remotely-window.vala"
				_tmp24_ = self->priv->display;
#line 245 "../src/remotely-window.vala"
				_tmp25_ = new_width;
#line 245 "../src/remotely-window.vala"
				g_object_set ((GtkWidget*) _tmp24_, "width-request", _tmp25_, NULL);
#line 246 "../src/remotely-window.vala"
				_tmp26_ = self->priv->display;
#line 246 "../src/remotely-window.vala"
				_tmp27_ = new_height;
#line 246 "../src/remotely-window.vala"
				g_object_set ((GtkWidget*) _tmp26_, "height-request", _tmp27_, NULL);
#line 248 "../src/remotely-window.vala"
				_tmp28_ = self->priv->vnc_display_box;
#line 248 "../src/remotely-window.vala"
				gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_CENTER);
#line 249 "../src/remotely-window.vala"
				_tmp29_ = self->priv->vnc_display_box;
#line 249 "../src/remotely-window.vala"
				gtk_widget_set_valign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
#line 251 "../src/remotely-window.vala"
				break;
#line 1343 "remotely-window.c"
			}
		}
#line 228 "../src/remotely-window.vala"
		case ZOOM_MODE_ORIGINAL_SIZE:
#line 1348 "remotely-window.c"
		{
			{
				VncDisplay* _tmp30_;
				VncDisplay* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				VncDisplay* _tmp34_;
				VncDisplay* _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
#line 254 "../src/remotely-window.vala"
				_tmp30_ = self->priv->display;
#line 254 "../src/remotely-window.vala"
				_tmp31_ = self->priv->display;
#line 254 "../src/remotely-window.vala"
				_tmp32_ = vnc_display_get_height (_tmp31_);
#line 254 "../src/remotely-window.vala"
				_tmp33_ = _tmp32_;
#line 254 "../src/remotely-window.vala"
				g_object_set ((GtkWidget*) _tmp30_, "height-request", _tmp33_, NULL);
#line 255 "../src/remotely-window.vala"
				_tmp34_ = self->priv->display;
#line 255 "../src/remotely-window.vala"
				_tmp35_ = self->priv->display;
#line 255 "../src/remotely-window.vala"
				_tmp36_ = vnc_display_get_width (_tmp35_);
#line 255 "../src/remotely-window.vala"
				_tmp37_ = _tmp36_;
#line 255 "../src/remotely-window.vala"
				g_object_set ((GtkWidget*) _tmp34_, "width-request", _tmp37_, NULL);
#line 256 "../src/remotely-window.vala"
				break;
#line 1381 "remotely-window.c"
			}
		}
		default:
#line 228 "../src/remotely-window.vala"
		break;
#line 1387 "remotely-window.c"
	}
}


static void
remotely_window_optiscale (RemotelyWindow* self,
                           gint box_width,
                           gint box_height,
                           gint image_width,
                           gint image_height,
                           gint* new_width,
                           gint* new_height)
{
	gint _vala_new_width = 0;
	gint _vala_new_height = 0;
	gint _tmp1_;
#line 261 "../src/remotely-window.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/remotely-window.vala"
	_vala_new_width = image_width;
#line 263 "../src/remotely-window.vala"
	_vala_new_height = image_height;
#line 266 "../src/remotely-window.vala"
	if (image_width > box_width) {
#line 1412 "remotely-window.c"
		gint _tmp0_;
#line 268 "../src/remotely-window.vala"
		_vala_new_width = box_width;
#line 270 "../src/remotely-window.vala"
		_tmp0_ = _vala_new_width;
#line 270 "../src/remotely-window.vala"
		_vala_new_height = (_tmp0_ * image_height) / image_width;
#line 1420 "remotely-window.c"
	}
#line 274 "../src/remotely-window.vala"
	_tmp1_ = _vala_new_height;
#line 274 "../src/remotely-window.vala"
	if (_tmp1_ > box_height) {
#line 1426 "remotely-window.c"
		gint _tmp2_;
#line 276 "../src/remotely-window.vala"
		_vala_new_height = box_height;
#line 278 "../src/remotely-window.vala"
		_tmp2_ = _vala_new_height;
#line 278 "../src/remotely-window.vala"
		_vala_new_width = (_tmp2_ * image_width) / image_height;
#line 1434 "remotely-window.c"
	}
#line 261 "../src/remotely-window.vala"
	if (new_width) {
#line 261 "../src/remotely-window.vala"
		*new_width = _vala_new_width;
#line 1440 "remotely-window.c"
	}
#line 261 "../src/remotely-window.vala"
	if (new_height) {
#line 261 "../src/remotely-window.vala"
		*new_height = _vala_new_height;
#line 1446 "remotely-window.c"
	}
}


static void
remotely_window_class_init (RemotelyWindowClass * klass)
{
#line 29 "../src/remotely-window.vala"
	remotely_window_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/remotely-window.vala"
	g_type_class_adjust_private_offset (klass, &RemotelyWindow_private_offset);
#line 29 "../src/remotely-window.vala"
	G_OBJECT_CLASS (klass)->finalize = remotely_window_finalize;
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/de/haeckerfelix/Remotely/ui/window.ui");
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connect_entry", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, connect_entry));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connect_stack", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, connect_stack));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "vnc_stack", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, vnc_stack));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connection_revealer", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, connection_revealer));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "view_only_checkbutton", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, view_only_checkbutton));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notification_revealer", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, notification_revealer));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notification_label", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, notification_label));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "vnc_display_box", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, vnc_display_box));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "scrolled_window", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, scrolled_window));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "username_entry", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, username_entry));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "username_label", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, username_label));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clientname_entry", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, clientname_entry));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clientname_label", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, clientname_label));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "password_entry", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, password_entry));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "password_label", FALSE, RemotelyWindow_private_offset + G_STRUCT_OFFSET (RemotelyWindowPrivate, password_label));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "connect_button_clicked", G_CALLBACK(_remotely_window_connect_button_clicked_gtk_button_clicked));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "disconnect_button_clicked", G_CALLBACK(_remotely_window_disconnect_button_clicked_gtk_button_clicked));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "authenticate_button_clicked", G_CALLBACK(_remotely_window_authenticate_button_clicked_gtk_button_clicked));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "view_best_fit_button_clicked", G_CALLBACK(_remotely_window_view_best_fit_button_clicked_gtk_button_clicked));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "view_fit_window_button_clicked", G_CALLBACK(_remotely_window_view_fit_window_button_clicked_gtk_button_clicked));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "view_original_size_button_clicked", G_CALLBACK(_remotely_window_view_original_size_button_clicked_gtk_button_clicked));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "view_only_button_clicked", G_CALLBACK(_remotely_window_view_only_button_clicked_gtk_button_clicked));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "ctrlaltdel_clicked", G_CALLBACK(_remotely_window_ctrlaltdel_clicked_gtk_button_clicked));
#line 29 "../src/remotely-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "notification_close_button_clicked", G_CALLBACK(_remotely_window_notification_close_button_clicked_gtk_button_clicked));
#line 1510 "remotely-window.c"
}


static void
remotely_window_instance_init (RemotelyWindow * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/remotely-window.vala"
	self->priv = remotely_window_get_instance_private (self);
#line 52 "../src/remotely-window.vala"
	self->priv->zoom_mode = ZOOM_MODE_BEST_FIT;
#line 53 "../src/remotely-window.vala"
	_tmp0_ = g_strdup ("localhost");
#line 53 "../src/remotely-window.vala"
	self->priv->host = _tmp0_;
#line 54 "../src/remotely-window.vala"
	_tmp1_ = g_strdup ("5900");
#line 54 "../src/remotely-window.vala"
	self->priv->port = _tmp1_;
#line 29 "../src/remotely-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1533 "remotely-window.c"
}


static void
remotely_window_finalize (GObject * obj)
{
	RemotelyWindow * self;
#line 29 "../src/remotely-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, REMOTELY_TYPE_WINDOW, RemotelyWindow);
#line 31 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->connect_entry);
#line 32 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->connect_stack);
#line 34 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->vnc_stack);
#line 35 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->connection_revealer);
#line 36 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->view_only_checkbutton);
#line 38 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->notification_revealer);
#line 39 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->notification_label);
#line 41 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->vnc_display_box);
#line 42 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->scrolled_window);
#line 44 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->username_entry);
#line 45 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->username_label);
#line 46 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->clientname_entry);
#line 47 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->clientname_label);
#line 48 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 49 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->password_label);
#line 51 "../src/remotely-window.vala"
	_g_object_unref0 (self->priv->display);
#line 53 "../src/remotely-window.vala"
	_g_free0 (self->priv->host);
#line 54 "../src/remotely-window.vala"
	_g_free0 (self->priv->port);
#line 29 "../src/remotely-window.vala"
	G_OBJECT_CLASS (remotely_window_parent_class)->finalize (obj);
#line 1581 "remotely-window.c"
}


GType
remotely_window_get_type (void)
{
	static volatile gsize remotely_window_type_id__volatile = 0;
	if (g_once_init_enter (&remotely_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RemotelyWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) remotely_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RemotelyWindow), 0, (GInstanceInitFunc) remotely_window_instance_init, NULL };
		GType remotely_window_type_id;
		remotely_window_type_id = g_type_register_static (gtk_application_window_get_type (), "RemotelyWindow", &g_define_type_info, 0);
		RemotelyWindow_private_offset = g_type_add_instance_private (remotely_window_type_id, sizeof (RemotelyWindowPrivate));
		g_once_init_leave (&remotely_window_type_id__volatile, remotely_window_type_id);
	}
	return remotely_window_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



